diff -r -c -b -B -N cosmomc/source/inifile.f90 cosmomc_sampler/source/inifile.f90
*** cosmomc/source/inifile.f90	1970-01-01 01:00:00.000000000 +0100
--- cosmomc_sampler/source/inifile.f90	2009-10-28 17:53:34.280467989 +0100
***************
*** 0 ****
--- 1,671 ----
+ !Module to read in name/value pairs from a file, with each line of the form line 'name = value'
+ !Should correctly interpret FITS headers
+ !Antony Lewis (http://cosmologist.info/). Released to the public domain.
+ !This version Oct 2009.
+ 
+ module IniFile
+  implicit none
+  public
+ 
+   integer, parameter :: Ini_max_name_len = 128
+ 
+   integer, parameter :: Ini_max_string_len = 1024
+   logical :: Ini_fail_on_not_found = .false.
+ 
+   logical :: Ini_Echo_Read = .false.
+ 
+   type TNameValue
+    !no known way to make character string pointers..
+     character(Ini_max_name_len)  :: Name
+     character(Ini_max_string_len):: Value
+   end type TNameValue
+ 
+   type TNameValue_pointer
+      Type(TNameValue), pointer :: P
+   end type TNameValue_pointer
+ 
+   Type TNameValueList
+     integer Count
+     integer Delta
+     integer Capacity
+     type(TNameValue_pointer), dimension(:), pointer :: Items
+   end Type TNameValueList
+ 
+   Type TIniFile
+    logical SlashComments
+    Type (TNameValueList) :: L, ReadValues
+   end Type TIniFile
+  
+   Type(TIniFile) :: DefIni
+ 
+ contains
+ 
+    subroutine TNameValueList_Init(L)
+     Type (TNameValueList) :: L
+     
+      L%Count = 0
+      L%Capacity = 0
+      L%Delta = 128
+      nullify(L%Items)
+ 
+    end subroutine TNameValueList_Init
+ 
+    subroutine TNameValueList_Clear(L)
+     Type (TNameValueList) :: L
+     integer i, status
+      
+     do i=L%count,1,-1
+      deallocate (L%Items(i)%P, stat = status)
+     end do
+     deallocate (L%Items, stat = status)
+     call TNameValueList_Init(L)
+ 
+    end subroutine TNameValueList_Clear
+ 
+    subroutine TNameValueList_ValueOf(L, AName, AValue)
+      Type (TNameValueList), intent(in) :: L
+      character(LEN=*), intent(in) :: AName
+      CHARACTER(LEN=*), intent(out) :: AValue
+      integer i
+ 
+      do i=1, L%Count
+        if (L%Items(i)%P%Name == AName) then
+           AValue = L%Items(i)%P%Value 
+           return
+        end if
+      end do
+      AValue = ''
+ 
+    end subroutine TNameValueList_ValueOf
+ 
+    function TNameValueList_HasKey(L, AName) result (AValue)
+      Type (TNameValueList), intent(in) :: L
+      character(LEN=*), intent(in) :: AName
+      logical :: AValue
+      integer i
+ 
+      do i=1, L%Count
+        if (L%Items(i)%P%Name == AName) then
+           AValue = .true.
+           return
+        end if
+      end do
+      AValue = .false.
+      
+    end function TNameValueList_HasKey
+     
+    subroutine TNameValueList_Add(L, AName, AValue)
+     Type (TNameValueList) :: L
+     character(LEN=*), intent(in) :: AName, AValue
+ 
+     if (L%Count == L%Capacity) call TNameValueList_SetCapacity(L, L%Capacity + L%Delta)
+     L%Count = L%Count + 1
+     allocate(L%Items(L%Count)%P)
+     L%Items(L%Count)%P%Name = AName
+     L%Items(L%Count)%P%Value = AValue
+ 
+    end subroutine TNameValueList_Add
+ 
+    subroutine TNameValueList_SetCapacity(L, C)
+     Type (TNameValueList) :: L
+     integer C
+     type(TNameValue_pointer), dimension(:), pointer :: TmpItems
+     
+     if (L%Count > 0) then
+       if (C < L%Count) stop 'TNameValueList_SetCapacity: smaller than Count'
+       allocate(TmpItems(L%Count))
+       TmpItems = L%Items(1:L%Count)
+       deallocate(L%Items)
+       allocate(L%Items(C))
+       L%Items(1:L%Count) = TmpItems
+       deallocate(TmpItems)
+     else
+      allocate(L%Items(C))
+     end if  
+     L%Capacity = C
+   
+    end subroutine TNameValueList_SetCapacity
+ 
+    subroutine TNameValueList_Delete(L, i)
+     Type (TNameValueList) :: L
+     integer, intent(in) :: i
+      
+      deallocate(L%Items(i)%P)
+      if (L%Count > 1) L%Items(i:L%Count-1) = L%Items(i+1:L%Count)
+      L%Count = L%Count -1
+      
+    end subroutine TNameValueList_Delete
+ 
+   subroutine Ini_NameValue_Add(Ini,AInLine)
+     Type(TIniFile) :: Ini
+     character (LEN=*), intent(IN) :: AInLine
+     integer EqPos, slashpos, lastpos
+     character (LEN=len(AInLine)) :: AName, S, InLine
+ 
+       InLine=trim(adjustl(AInLine))
+       EqPos = scan(InLine,'=')
+       if (EqPos/=0 .and. InLine(1:1)/='#' .and. InLine(1:7) /= 'COMMENT' ) then
+    
+          AName = trim(InLine(1:EqPos-1))
+          
+          S = adjustl(InLine(EqPos+1:)) 
+            if (Ini%SlashComments) then
+            slashpos=scan(S,'/')
+            if (slashpos /= 0) then
+               S  = S(1:slashpos-1)
+            end if
+          end if
+          lastpos=len_trim(S)
+          if (lastpos>1) then
+           if (S(1:1)=='''' .and. S(lastpos:lastpos)=='''') then
+            S = S(2:lastpos-1)
+           end if
+          end if
+          call TNameValueList_Add(Ini%L, AName, S)
+ 
+       end if
+ 
+   end subroutine Ini_NameValue_Add
+ 
+   subroutine Ini_Open(filename, unit_id,  error, slash_comments)
+      character (LEN=*), intent(IN) :: filename
+      integer, intent(IN) :: unit_id
+      logical, optional, intent(OUT) :: error
+      logical, optional, intent(IN) :: slash_comments
+      logical aerror
+ 
+      call TNameValueList_Init(DefIni%L)
+      call TNameValueList_Init(DefIni%ReadValues)
+           
+      if (present(slash_comments)) then
+       call Ini_Open_File(DefIni,filename,unit_id,aerror,slash_comments)
+      else
+       call Ini_Open_File(DefIni,filename,unit_id,aerror)
+      end if
+ 
+      if (present(error)) then
+        error = aerror
+      else
+       if (aerror) then
+         write (*,*) 'Ini_Open: Error opening file ' // trim(filename)
+         stop
+       end if
+      end if
+ 
+   end subroutine Ini_Open
+ 
+ 
+ 
+   subroutine Ini_Open_File(Ini, filename, unit_id,  error, slash_comments)
+      Type(TIniFile) :: Ini
+ 
+      character (LEN=*), intent(IN) :: filename
+      integer, intent(IN) :: unit_id
+      logical, intent(OUT) :: error
+      logical, optional, intent(IN) :: slash_comments
+      character (LEN=120) :: InLine
+     
+ 
+     call TNameValueList_Init(Ini%L)
+     call TNameValueList_Init(Ini%ReadValues)
+ 
+     if (present(slash_comments)) then
+      Ini%SlashComments = slash_comments
+     else
+      Ini%SlashComments = .false.
+     end if
+          
+     open(unit=unit_id,file=filename,form='formatted',status='old', err=500)
+    
+     do 
+       read (unit_id,'(a)',end=400) InLine
+       if (InLine == 'END') exit;
+       if (InLine /= '') call Ini_NameValue_Add(Ini,InLine) 
+     end do
+ 
+ 400 close(unit_id)
+     error=.false.
+     return
+ 
+ 500 error=.true.
+ 
+   end subroutine Ini_Open_File
+ 
+   subroutine Ini_Open_Fromlines(Ini, Lines, NumLines, slash_comments)
+     Type(TIniFile) :: Ini
+ 
+     integer, intent(IN) :: NumLines
+     character (LEN=*), dimension(NumLines), intent(IN) :: Lines
+     logical, intent(IN) :: slash_comments
+     integer i
+ 
+     call TNameValueList_Init(Ini%L)
+     call TNameValueList_Init(Ini%ReadValues)
+ 
+     Ini%SlashComments = slash_comments
+ 
+     do i=1,NumLines
+        call Ini_NameValue_Add(Ini,Lines(i))
+     end do
+ 
+   end  subroutine Ini_Open_Fromlines
+ 
+   subroutine Ini_Close
+ 
+     call Ini_close_File(DefIni)
+ 
+   end subroutine Ini_Close
+ 
+ 
+   subroutine Ini_Close_File(Ini)
+     Type(TIniFile) :: Ini
+    
+     call TNameValueList_Clear(Ini%L)
+     call TNameValueList_Clear(Ini%ReadValues)
+ 
+   end  subroutine Ini_Close_File
+   
+ 
+ 
+   function Ini_Read_String(Key, NotFoundFail) result(AValue)
+    character (LEN=*), intent(IN) :: Key
+    logical, optional, intent(IN) :: NotFoundFail
+    character(LEN=Ini_max_string_len) :: AValue
+ 
+      if (present(NotFoundFail)) then
+       AValue = Ini_Read_String_File(DefIni, Key, NotFoundFail)
+      else
+       AValue = Ini_Read_String_File(DefIni, Key)
+      end if
+ 
+   end function Ini_Read_String
+ 
+ 
+   function Ini_Read_String_File(Ini, Key, NotFoundFail) result(AValue)
+    Type(TIniFile) :: Ini
+    character (LEN=*), intent(IN) :: Key
+    logical, optional, intent(IN) :: NotFoundFail
+    character(LEN=Ini_max_string_len) :: AValue
+ 
+    call TNameValueList_ValueOf(Ini%L, Key, AValue)
+ 
+    if (AValue/='') then
+ 
+     call  TNameValueList_Add(Ini%ReadValues, Key, AValue)
+     if (Ini_Echo_Read) write (*,*) trim(Key)//' = ',trim(AValue)
+     return
+ 
+    end if
+    if (present(NotFoundFail)) then
+       if (NotFoundFail) then
+          write(*,*) 'key not found : '//trim(Key)
+          stop
+       end if
+    else if (Ini_fail_on_not_found) then
+       write(*,*) 'key not found : '//trim(Key)
+       stop
+    end if
+ 
+   end function Ini_Read_String_File
+   function Ini_HasKey(Key) result(AValue)
+    character (LEN=*), intent(IN) :: Key
+    logical AValue
+ 
+    AValue = Ini_HasKey_File(DefIni, Key)
+ 
+   end function Ini_HasKey
+ 
+   function Ini_HasKey_File(Ini, Key) result(AValue)
+    type(TIniFile), intent(in) :: Ini
+    character (LEN=*), intent(IN) :: Key
+    logical AValue
+ 
+       Avalue = TNameValueList_HasKey(Ini%L, Key)
+       
+   end function Ini_HasKey_File
+ 
+  function Ini_Key_To_Arraykey(Key, index)  result(AValue)
+     character (LEN=*), intent(IN) :: Key
+     integer, intent(in) :: index
+     character(LEN=Ini_max_string_len) :: AValue
+     
+     character(LEN=32) :: numstr
+     write (numstr,*) index 
+     numstr=adjustl(numstr)
+     AValue = trim(Key) // '(' // trim(numStr) // ')' 
+  
+  end function Ini_Key_To_Arraykey
+ 
+   function Ini_Read_String_Array(Key, index, NotFoundFail) result(AValue)
+    character (LEN=*), intent(IN) :: Key
+    integer, intent(in) :: index
+    logical, optional, intent(IN) :: NotFoundFail
+    character(LEN=Ini_max_string_len) :: AValue
+ 
+      if (present(NotFoundFail)) then
+       AValue = Ini_Read_String_Array_File(DefIni, Key, index, NotFoundFail)
+      else
+       AValue = Ini_Read_String_Array_File(DefIni, Key, index)
+      end if
+ 
+   end function Ini_Read_String_Array
+ 
+   function Ini_Read_String_Array_File(Ini, Key, index, NotFoundFail) result(AValue)
+    Type(TIniFile) :: Ini
+    integer, intent(in) :: index
+    character (LEN=*), intent(IN) :: Key
+    logical, optional, intent(IN) :: NotFoundFail
+    character(LEN=Ini_max_string_len) :: AValue
+    character(LEN=Ini_max_string_len) :: ArrayKey
+    
+      ArrayKey = Ini_Key_To_Arraykey(Key,index)
+      if (present(NotFoundFail)) then
+       AValue = Ini_Read_String_File(Ini, ArrayKey, NotFoundFail)
+      else
+       AValue = Ini_Read_String_File(Ini, ArrayKey)
+      end if
+    
+   end function Ini_Read_String_Array_File
+ 
+   function Ini_Read_Int_Array(Key, index, Default)
+      integer, optional, intent(IN) :: Default
+      integer, intent(in) :: index
+      character (LEN=*), intent(IN) :: Key
+      integer Ini_Read_Int_Array
+ 
+      if (present(Default)) then
+       Ini_Read_Int_Array = Ini_Read_Int_Array_File(DefIni, Key, index, Default)
+      else
+       Ini_Read_Int_Array = Ini_Read_Int_Array_File(DefIni, Key, index)
+      end if
+      
+    end function Ini_Read_Int_Array
+ 
+   function Ini_Read_Int_Array_File(Ini,Key, index, Default)
+   !Reads Key(1), Key(2), etc.
+    Type(TIniFile) :: Ini
+    integer Ini_Read_Int_Array_File 
+    integer, optional, intent(IN) :: Default
+    integer, intent(in) :: index
+    character (LEN=*), intent(IN) :: Key
+    character(LEN=Ini_max_string_len) :: ArrrayKey
+      ArrrayKey = Ini_Key_To_Arraykey(Key,index)
+      if (present(Default)) then
+       Ini_Read_Int_Array_File = Ini_Read_Int_File(Ini, ArrrayKey, Default)
+      else
+       Ini_Read_Int_Array_File = Ini_Read_Int_File(Ini, ArrrayKey)
+      end if
+   end function Ini_Read_Int_Array_File
+ 
+ 
+   function Ini_Read_Int(Key, Default)
+      integer, optional, intent(IN) :: Default
+      character (LEN=*), intent(IN) :: Key
+      integer Ini_Read_Int
+ 
+      if (present(Default)) then
+       Ini_Read_Int = Ini_Read_Int_File(DefIni, Key, Default)
+      else
+       Ini_Read_Int = Ini_Read_Int_File(DefIni, Key)
+      end if
+   end function Ini_Read_Int
+ 
+   function Ini_Read_Int_File(Ini, Key, Default)
+    Type(TIniFile) :: Ini
+    integer Ini_Read_Int_File
+    integer, optional, intent(IN) :: Default
+    character  (LEN=*), intent(IN) :: Key
+    character(LEN=Ini_max_string_len) :: S
+    
+    S = Ini_Read_String_File(Ini, Key,.not. present(Default))
+    if (S == '') then
+       if (.not. present(Default)) then
+         write(*,*) 'no value for key: '//Key
+         stop
+       end if
+       Ini_Read_Int_File = Default
+       write (S,*) Default
+       call  TNameValueList_Add(Ini%ReadValues, Key, S)
+    else
+     if (verify(trim(S),'-+0123456789') /= 0) goto 10
+     read (S,*, err = 10) Ini_Read_Int_File
+    end if
+   return
+ 10 write (*,*) 'error reading integer for key: '//Key
+    stop
+   
+   end function Ini_Read_Int_File
+ 
+   function Ini_Read_Double(Key, Default)
+      double precision, optional, intent(IN) :: Default
+      character (LEN=*), intent(IN) :: Key
+      double precision Ini_Read_Double
+ 
+      if (present(Default)) then
+       Ini_Read_Double = Ini_Read_Double_File(DefIni, Key, Default)
+      else
+       Ini_Read_Double = Ini_Read_Double_File(DefIni, Key)
+      end if
+   
+   end function Ini_Read_Double
+ 
+   function Ini_Read_Double_File(Ini,Key, Default)
+    Type(TIniFile) :: Ini
+    double precision Ini_Read_Double_File 
+    double precision, optional, intent(IN) :: Default
+    character (LEN=*), intent(IN) :: Key
+    character(LEN=Ini_max_string_len) :: S
+    
+    S = Ini_Read_String_File(Ini,Key,.not. present(Default))
+    if (S == '') then
+       if (.not. present(Default)) then
+         write(*,*) 'no value for key: '//Key
+         stop
+       end if
+       Ini_Read_Double_File = Default
+       write (S,*) Default
+ 
+       call  TNameValueList_Add(Ini%ReadValues, Key, S)
+ 
+    else
+     read (S,*, err=10) Ini_Read_Double_File
+    end if
+ 
+   return
+ 
+ 10 write (*,*) 'error reading double for key: '//Key
+    stop
+ 
+   end function Ini_Read_Double_File
+ 
+ 
+ 
+     function Ini_Read_Double_Array(Key, index, Default)
+      double precision, optional, intent(IN) :: Default
+      integer, intent(in) :: index
+      character (LEN=*), intent(IN) :: Key
+      double precision Ini_Read_Double_Array
+ 
+      if (present(Default)) then
+       Ini_Read_Double_Array = Ini_Read_Double_Array_File(DefIni, Key, index, Default)
+      else
+       Ini_Read_Double_Array = Ini_Read_Double_Array_File(DefIni, Key, index)
+      end if
+      
+     end function Ini_Read_Double_Array
+ 
+ 
+   function Ini_Read_Double_Array_File(Ini,Key, index, Default)
+ 
+   !Reads Key(1), Key(2), etc.
+ 
+    Type(TIniFile) :: Ini
+ 
+    double precision Ini_Read_Double_Array_File 
+    double precision, optional, intent(IN) :: Default
+    integer, intent(in) :: index
+    character (LEN=*), intent(IN) :: Key
+    character(LEN=Ini_max_string_len) ::  ArrrayKey
+ 
+      ArrrayKey = Ini_Key_To_Arraykey(Key,index)
+      if (present(Default)) then
+ 
+       Ini_Read_Double_Array_File = Ini_Read_Double_File(Ini, ArrrayKey, Default)
+      else
+       Ini_Read_Double_Array_File = Ini_Read_Double_File(Ini, ArrrayKey)
+      end if
+   end function Ini_Read_Double_Array_File
+ 
+     function Ini_Read_Real(Key, Default)
+      real, optional, intent(IN) :: Default
+      character (LEN=*), intent(IN) :: Key
+      real Ini_Read_Real
+ 
+      if (present(Default)) then
+       Ini_Read_Real = Ini_Read_Real_File(DefIni, Key, Default)
+      else
+       Ini_Read_Real = Ini_Read_Real_File(DefIni, Key)
+      end if
+ 
+     end function Ini_Read_Real
+ 
+     function Ini_Read_Real_File(Ini,Key, Default)
+     Type(TIniFile) :: Ini
+     real Ini_Read_Real_File 
+     real, optional, intent(IN) :: Default
+     character (LEN=*), intent(IN) :: Key
+     character(LEN=Ini_max_string_len) :: S
+    
+     S = Ini_Read_String_File(Ini,Key,.not. present(Default))
+     if (S == '') then
+       if (.not. present(Default)) then
+         write(*,*) 'no value for key: '//Key
+         stop
+       end if
+       Ini_Read_Real_File = Default
+       write (S,*) Default
+       call  TNameValueList_Add(Ini%ReadValues, Key, S)
+ 
+    else
+     read (S,*, err=10) Ini_Read_Real_File
+    end if
+ 
+   return
+ 
+ 10 write (*,*) 'error reading double for key: '//Key
+    stop
+ 
+   end function Ini_Read_Real_File
+ 
+ 
+ 
+    function Ini_Read_Real_Array(Key, index, Default)
+      real, optional, intent(IN) :: Default
+      integer, intent(in) :: index
+      character (LEN=*), intent(IN) :: Key
+      real Ini_Read_Real_Array
+ 
+      if (present(Default)) then
+       Ini_Read_Real_Array = Ini_Read_Real_Array_File(DefIni, Key, index, Default)
+      else
+       Ini_Read_Real_Array = Ini_Read_Real_Array_File(DefIni, Key, index)
+      end if
+    end function Ini_Read_Real_Array
+ 
+   function Ini_Read_Real_Array_File(Ini,Key, index, Default)
+   !Reads Key(1), Key(2), etc.
+    Type(TIniFile) :: Ini
+    real Ini_Read_Real_Array_File 
+    real, optional, intent(IN) :: Default
+    integer, intent(in) :: index
+    character (LEN=*), intent(IN) :: Key
+    character(LEN=Ini_max_string_len) :: ArrrayKey
+    
+      ArrrayKey = Ini_Key_To_Arraykey(Key,index)
+      if (present(Default)) then
+       Ini_Read_Real_Array_File = Ini_Read_Real_File(Ini, ArrrayKey, Default)
+      else
+       Ini_Read_Real_Array_File = Ini_Read_Real_File(Ini, ArrrayKey)
+      end if
+   end function Ini_Read_Real_Array_File
+ 
+   function Ini_Read_Logical(Key, Default)
+      Logical, optional, intent(IN) :: Default
+      character (LEN=*), intent(IN) :: Key
+     logical Ini_Read_Logical
+ 
+      if (present(Default)) then
+       Ini_Read_Logical = Ini_Read_Logical_File(DefIni, Key, Default)
+      else
+       Ini_Read_Logical = Ini_Read_Logical_File(DefIni, Key)
+      end if
+   end function Ini_Read_Logical
+ 
+   function Ini_Read_Logical_File(Ini, Key, Default)
+    Type(TIniFile) :: Ini
+ 
+    logical Ini_Read_Logical_File
+    logical, optional, intent(IN) :: Default
+    character  (LEN=*), intent(IN) :: Key
+   
+    character(LEN=Ini_max_string_len) :: S
+    
+    S = Ini_Read_String_File(Ini,Key,.not. present(Default))
+    if (S == '') then
+       if (.not. present(Default)) then
+         write(*,*) 'no value for key: '//Key
+         stop
+       end if
+       Ini_Read_Logical_File = Default
+       write (S,*) Default
+ 
+       call  TNameValueList_Add(Ini%ReadValues, Key, S)
+ 
+    else
+ 
+     if (verify(trim(S),'10TF') /= 0) goto 10  
+     read (S,*, err = 10) Ini_Read_Logical_File
+    end if
+ 
+   return
+ 
+ 10 write (*,*) 'error reading logical for key: '//Key
+    stop
+   end function Ini_Read_Logical_File
+ 
+ 
+ 
+   subroutine Ini_SaveReadValues(afile,unit_id)
+    character(LEN=*)  :: afile
+    integer, intent(in) :: unit_id
+ 
+    call Ini_SaveReadValues_File(DefIni, afile, unit_id)
+ 
+   end subroutine Ini_SaveReadValues
+ 
+ 
+ 
+   subroutine Ini_SaveReadValues_File(Ini, afile, unit_id)
+    Type(TIniFile) :: Ini
+    character(LEN=*), intent(in) :: afile
+    integer, intent(in) :: unit_id
+    integer i
+ 
+    open(unit=unit_id,file=afile,form='formatted',status='replace', err=500)
+ 
+    do i=1, Ini%ReadValues%Count
+ 
+     write (unit_id,'(a)') trim(Ini%ReadValues%Items(i)%P%Name) // ' = ' &
+                         //trim(Ini%ReadValues%Items(i)%P%Value)
+ 
+    end do
+ 
+    close(unit_id)
+    return
+ 
+ 500 write(*,*) 'Ini_SaveReadValues_File: Error creating '//trim(afile)
+ 
+   end subroutine Ini_SaveReadValues_File
+ 
+ end module IniFile
+ 
diff -r -c -b -B -N cosmomc/source/Makefile cosmomc_sampler/source/Makefile
*** cosmomc/source/Makefile	2009-10-27 16:42:57.000000000 +0100
--- cosmomc_sampler/source/Makefile	2009-10-28 17:56:08.384509654 +0100
***************
*** 1,195 ****
! #You may need to edit the library paths for MKL for Intel
! #Beware of using optmizations that lose accuracy - may give errors when running
  
! ##Uncomment the next line to include dr7 LRG
! EXTDATA = 
! #EXTDATA = LRG
! 
! #set WMAP empty not to compile with WMAP
! WMAP = /home/aml1005/WMAP5/likelihood_v3
! 
! #Only needed for WMAP
! cfitsio = /usr/local/cfitsio/intel10/64/3.040
! 
! #GSL only needed for DR7 LRG
! GSLPATH = /home/aml1005/libs/gsl
! 
! IFLAG = -I
! INCLUDE=
! 
! #Intel MPI (assuming mpif77 set to point to ifort)
! #change -lmkl_ia32 to -lmkl_p3 for MKL versions earlier than 6 (6 needed for ifc 8+) 
! F90C     = mpif90
! FFLAGS = -O2 -ip -W0 -WB -openmp -fpp -DMPI -vec_report0
! LAPACKL = -L/usr/local/intel/mkl/9.1/lib/em64t -lmkl_lapack -lmkl_em64t -lguide -lpthread
! 
! #HPCF settings. Use Inteal 9 or 10.1+, not 10.0
! #F90C     = mpif90
! #FFLAGS = -O2 -Vaxlib -W0 -WB -openmp -fpp -DMPI -vec_report0
! #LAPACKL = -L/usr/local/Cluster-Apps/intel/mkl/10.2.2.025/lib/em64t -lmkl_lapack -lmkl -lguide -lpthread
! #GSLPATH = /usr/local/Cluster-Apps/gsl/1.9
! #cfitsio = /usr/local/Cluster-Users/cpac/cmb/2.1.0/cfitsio
! #INCLUDE=
! 
! #COSMOS: use "module load cosmolib" "module load latest" "module load gsl.stable"
! #use "runCosmomc" (globally installed) to run, defining required memory usage
! ifeq ($(COSMOHOST),cosmos)
! F90C = ifort
! FFLAGS = -openmp -O3 -w -fpp2 -DMPI
! LAPACKL = -mkl=sequential -lmkl_lapack -lmpi
! cfitsio = $(CFITSIO)
! WMAP = /home/cosmos/share-ia64/likelihood_v3
! GSLPATH = $(GSL_ROOT)
  endif
  
! #Intel fortran 8, check you have the latest update from the Intel web pages
! #See Makefile_intel for ifc 7.1 or lower (some versions have problems)
! #F90C     = ifort
! #FFLAGS = -O2 -Vaxlib -ip -W0 -WB -openmp -fpp
! #LAPACKL = -L/opt/intel/mkl61/lib/32 -lmkl_lapack -lmkl_ia32 -lguide -lpthread
! 
! #G95; make sure LAPACK and MPI libs also compiled with g95
! #F90C     = mpif90
! #FFLAGS = -O2 -DMPI
! #LAPACKL = /LAPACK/lapack_LINUX.a /LAPACK/blas_LINUX.a
! 
! #GFortran: if pre v4.3 add -D__GFORTRAN__
! #F90C     = gfortran
! #FFLAGS = -O2 -ffree-form -x f95-cpp-input 
! #LAPACKL = -Wl,-framework -Wl,accelerate
! 
! #SGI, -mp toggles multi-processor. Use -O2 if -Ofast gives problems.
! #Not various versions of the compiler are buggy giving erroneous seg faults with -mp.
! #Version 7.3 is OK, currently version 7.4 is bugged, as are some earlier versions.
! #F90C     = f90
! #LAPACKL = -lcomplib.sgimath
! #FFLAGS  = -Ofast -mp
! 
! #Digital/Compaq fortran, -omp toggles multi-processor
! #F90C    = f90
! #FFLAGS  = -omp -O4 -arch host -math_library fast -tune host -fpe1
! #LAPACKL  = -lcxml
! 
! #Absoft ProFortran, single processor, set -cpu:[type] for your local system 
! #F90C     = f95
! #FFLAGS = -O2 -s -cpu:athlon -lU77 -w -YEXT_NAMES="LCS" -YEXT_SFX="_" 
! #LAPACKL =  -llapack -lblas -lg2c 
! #IFLAG = -p
! 
! #NAGF95, single processor:
! #F90C     = f95
! #FFLAGS = -DNAGF95 -O3
! #LAPACKL = -llapack -lblas -lg2c
! 
! #PGF90
! #F90C = pgf90
! #FFLAGS = -O2 -DESCAPEBACKSLASH
! #LAPACKL = -llapack -lblas
! 
! 
! #Sun, single processor:
! #F90C     = f90
! #FFLAGS = -fast -ftrap=%none
! #LAPACKL = -lsunperf -lfsu
! #LAPACKL = -lsunperf -lfsu -lsocket -lm
! #IFLAG = -M
! 
! #Sun MPI
! #F90C = mpf90
! #FFLAGS =  -O4 -openmp -ftrap=%none -dalign -DMPI
! #LAPACKL = -lsunperf -lfsu -lmpi_mt
! #IFLAG = -M
! 
! #Sun parallel enterprise:
! #F90C     = f95
! #FFLAGS =  -O4 -xarch=native64 -openmp -ftrap=%none
! #LAPACKL = -lsunperf -lfsu
! #IFLAG = -M
! 
! 
! #IBM XL Fortran, multi-processor (run "module load lapack" then run "gmake")
! # See also http://cosmocoffee.info/viewtopic.php?t=326
! #F90C     = xlf90_r $(LAPACK)
! #FFLAGS  = -WF,-DIBMXL -qsmp=omp -qsuffix=f=f90:cpp=F90 -O3 -qstrict -qarch=pwr3 -qtune=pwr3
! #INCLUDE = -lessl
! #LAPACKL =
  
! PROPOSE = propose.o
! CLSFILE = CMB_Cls_simple.o
  
! #Can use params_H if you prefer more generic parameters
! PARAMETERIZATION = params_CMB.o
  
! F90FLAGS = -DMATRIX_SINGLE $(FFLAGS) $(IFLAG)../camb $(INCLUDE)
! LINKFLAGS = -L../camb -lcamb $(LAPACKL) 
  
- DISTFILES = utils.o ParamNames.o Matrix_utils.o settings.o GetDist.o
  
! OBJFILES= utils.o ParamNames.o Matrix_utils.o settings.o IO.o cmbtypes.o Planck_like.o \
! 	cmbdata.o WeakLen.o bao.o lrggettheory.o mpk.o supernovae.o HST.o SDSSLy-a-v3.o \
! 	$(CLSFILE) paramdef.o $(PROPOSE) $(PARAMETERIZATION) calclike.o \
! 	conjgrad_wrapper.o EstCovmat.o postprocess.o MCMC.o driver.o
  
  
! ifeq ($(EXTDATA),LRG)
! F90FLAGS += -DDR71RG
! OBJFILES += bsplinepk.o
! GSLINC = -I$(GSLPATH)/include
! LINKFLAGS += -L$(GSLPATH)/lib -lgsl -lgslcblas
! endif
  
! ifneq ($(WMAP),)
! F90FLAGS += $(IFLAG)$(cfitsio)/include $(IFLAG)$(WMAP)
! LINKFLAGS +=  -L$(cfitsio)/lib -L$(WMAP) -lcfitsio
! OBJFILES += $(WMAP)/read_archive_map.o \
! 	$(WMAP)/read_fits.o \
! 	$(WMAP)/WMAP_5yr_options.o \
! 	$(WMAP)/WMAP_5yr_util.o \
! 	$(WMAP)/WMAP_5yr_tt_pixlike.o \
! 	$(WMAP)/WMAP_5yr_teeebb_pixlike.o \
! 	$(WMAP)/WMAP_5yr_likelihood.o \
! 	$(WMAP)/WMAP_5yr_gibbs.o \
! 	$(WMAP)/WMAP_5yr_tt_beam_ptsrc_chisq.o \
! 	$(WMAP)/br_mod_dist.o 
! else
! F90FLAGS += -DNOWMAP
! endif
  
! default: cosmomc
  
! all : cosmomc getdist
  
! utils.o: ../camb/libcamb.a
! settings.o: utils.o
! cmbtypes.o: settings.o
! Planck_like.o: cmbtypes.o
! cmbdata.o: Planck_like.o $(WMAPOBJS)
! WeakLen.o: cmbtypes.o
! bao.o: cmbtypes.o
! mpk.o: cmbtypes.o lrggettheory.o
! HST.o: cmbtypes.o
! supernovae.o: cmbtypes.o
! SDSSLy-a-v3.o: cmbtypes.o
! $(CLSFILE): cmbtypes.o mpk.o HST.o bao.o IO.o
! paramdef.o: $(CLSFILE)
! $(PROPOSE): paramdef.o
! $(PARAMETERIZATION): paramdef.o
! calclike.o: $(PARAMETERIZATION)
! conjgrad_wrapper.o: calclike.o
! EstCovmat.o: conjgrad_wrapper.o
! postprocess.o: calclike.o
! MCMC.o: calclike.o
! driver.o: MCMC.o
  
! export FFLAGS
! export F90C
  
  .f.o:
  	f77 $(F90FLAGS) -c $<
  
- %.o: %.c
- 	$(CC) $(GSLINC) -c $*.c
- 
  %.o: %.f90
  	$(F90C) $(F90FLAGS) -c $*.f90
  
--- 1,70 ----
! # >>> DESIGNED FOR GMAKE <<<
  
! # Unified Systems makefile for GENEMC
! # Add FLAGS -DMPI for using MPI
! 
! ext=$(shell uname | cut -c1-3)
! 
! ifeq ($(ext),IRI)
! F90C= f90
! FFLAGS= -Ofast -mp -n32 -LANG:recursive=ON -lmpi -DMPI
! LAPACKL = -lcomplib.sgimath_mp
! INCLUDE = 
  endif
  
! ifeq ($(ext),Lin)
! F90C=gfortran
! FFLAGS= -O -fopenmp 
! #LAPACKL = -L/opt/intel/mkl/10.1.2.024/lib/em64t -lmkl -lmkl_lapack
! LAPACKL = -llapack
! INCLUDE = -I/usr/include 
! endif 
  
! ifeq ($(ext),OSF)
! F90C=f90
! FFLAGS= -omp -O -arch host -math_library fast -tune host -fpe1
! WMAPFLAGS= $(FFLAGS)
! LAPACKL  = -lcxml
! INCLUDE = 
! endif
  
! ifeq ($(ext),Sun)
! F90C=f90
! FFLAGS= -O4 -xarch=native64 -openmp -ftrap=%none
! WMAPFLAGS= $(FFLAGS)
! LAPACKL = -lsunperf -lfsu
! INCLUDE =
! endif
  
! ifeq ($(ext),AIX)
! F90C    = mpxlf90_r
! FFLAGS  = -O4 -WF,-DIBMXL,-DMPI -qstrict -qsmp=omp -qmaxmem=-1 -qsuffix=f=f90:cpp=F90
! LAPACKL = -lessl
! INCLUDE = 
! endif
  
  
! PROPOSE = propose.o
  
+ PARAMETERIZATION = params_EXT.o
  
! MCMCLIB = $(LAPACKL)
  
! F90FLAGS = -DMATRIX_SINGLE $(FFLAGS) $(INCLUDE)
  
! DISTFILES = utils.o ParamNames.o Matrix_utils.o settings.o GetDist.o
  
! OBJFILES= inifile.o utils.o ParamNames.o Matrix_utils.o  settings.o IO.o \
! 	paramdef.o wrapper.o $(PROPOSE) $(PARAMETERIZATION) calclike.o \
! 	conjgrad_wrapper.o EstCovmat.o postprocess.o MCMC.o driver.o
  
! default: genemc.$(ext)
  
! all : genemc.$(ext) getdist.$(ext)
  
  .f.o:
  	f77 $(F90FLAGS) -c $<
  
  %.o: %.f90
  	$(F90C) $(F90FLAGS) -c $*.f90
  
***************
*** 197,215 ****
  	$(F90C) $(F90FLAGS) -c $*.F90
  
  
! cosmomc: camb $(OBJFILES)
! 	$(F90C) -o ../cosmomc $(OBJFILES) $(LINKFLAGS) $(F90FLAGS)
  
! 
! clean: cleancosmomc
! 	rm -f ../camb/*.o ../camb/*.obj
! 
! cleancosmomc:
  	rm -f *.o *.mod *.d *.pc *.obj ../core 
  
! 
! getdist: camb $(DISTFILES)
! 	$(F90C) -o ../getdist $(DISTFILES) $(LINKFLAGS) $(F90FLAGS) 
! 
! camb:
! 	cd ../camb && $(MAKE) --file=Makefile_main libcamb.a
--- 72,82 ----
  	$(F90C) $(F90FLAGS) -c $*.F90
  
  
! genemc.$(ext): $(OBJFILES)
! 	$(F90C) -o ../$@ $(OBJFILES) $(MCMCLIB) $(F90FLAGS)
  
! clean:
  	rm -f *.o *.mod *.d *.pc *.obj ../core
  
! getdist.$(ext): $(DISTFILES)
! 	$(F90C) -o ../$@ $(DISTFILES) $(CLSLIB) $(F90FLAGS) 
diff -r -c -b -B -N cosmomc/source/MCMC.f90 cosmomc_sampler/source/MCMC.f90
*** cosmomc/source/MCMC.f90	2009-09-18 18:32:05.000000000 +0200
--- cosmomc_sampler/source/MCMC.f90	2009-10-28 17:29:14.528217970 +0100
***************
*** 8,13 ****
--- 8,14 ----
   use CalcLike
   use Random
   use propose
+  use wrapper
   use IO
   implicit none
  
